LPARAM lcDump,loDump

**************************************************************************
** Program name: dumpfll2txt.PRG
** Version: 0.0.2
** Create date: 2005-01-23
** Description: Save Dump from fll/dll to dump file
** Author: Martin Jindra
** E-mail: martin.jindra@egservis.cz
** CP: 1250

CLEAR
IF PCOUNT()<2 OR TYPE("lcDump")#"C" OR TYPE("loDump")#"O"
   ?"Parameter panic"
ENDIF

#INCLUDE "dumpfll.h"
LOCAL lii,loObj,liMax,liy

IF !__StartDoc(lcDump)
   ?"Cannot create dump file."
   RETURN
ENDIF

\Signature: <<loDump.cSignature>>
\

\IMAGE_FILE_HEADER
\Machine:              <<TRANSFORM(loDump.iMachine,"@0")>>
\NumberOfSections:     <<TRANSFORM(loDump.iNumberOfSections,"@0")>>
\TimeDateStamp:        <<TRANSFORM(loDump.iTimeDateStamp,"@0")>>
\PointerToSymbolTable: <<TRANSFORM(loDump.iPointerToSymbolTable,"@0")>>
\NumberOfSymbols:      <<TRANSFORM(loDump.iNumberOfSymbols,"@0")>>
\SizeOfOptionalHeader: <<TRANSFORM(loDump.iSizeOfOptionalHeader,"@0")>>
\Characteristics:      <<TRANSFORM(loDump.iCharacteristics,"@0")>>


\
\IMAGE_OPTIONAL_HEADER
\Magic:                       <<TRANSFORM(loDump.iMagic,"@0")>>
\MajorLinkerVersion:          <<TRANSFORM(loDump.iMajorLinkerVersion,"@0")>>
\MinorLinkerVersion:          <<TRANSFORM(loDump.iMinorLinkerVersion,"@0")>>
\SizeOfCode:                  <<TRANSFORM(loDump.iSizeOfCode,"@0")>>
\SizeOfInitializedData:       <<TRANSFORM(loDump.iSizeOfInitializedData,"@0")>>
\SizeOfUninitializedData:     <<TRANSFORM(loDump.iSizeOfUninitializedData,"@0")>>
\AddressOfEntryPoint:         <<TRANSFORM(loDump.iAddressOfEntryPoint,"@0")>>
\BaseOfCode:                  <<TRANSFORM(loDump.iBaseOfCode,"@0")>>
\BaseOfData:                  <<TRANSFORM(loDump.iBaseOfData,"@0")>>
\ImageBase:                   <<TRANSFORM(loDump.iImageBase,"@0")>>
\SectionAlignment:            <<TRANSFORM(loDump.iSectionAlignment,"@0")>>
\FileAlignment:               <<TRANSFORM(loDump.iFileAlignment,"@0")>>
\MajorOperatingSystemVersion: <<TRANSFORM(loDump.iMajorOperatingSystemVersion,"@0")>>
\MinorOperatingSystemVersion: <<TRANSFORM(loDump.iMinorOperatingSystemVersion,"@0")>>
\MajorImageVersion:           <<TRANSFORM(loDump.iMajorImageVersion,"@0")>>
\MinorImageVersion:           <<TRANSFORM(loDump.iMinorImageVersion,"@0")>>
\MajorSubsystemVersion:       <<TRANSFORM(loDump.iMajorSubsystemVersion,"@0")>>
\MinorSubsystemVersion:       <<TRANSFORM(loDump.iMinorSubsystemVersion,"@0")>>
\Win32VersionValue:           <<TRANSFORM(loDump.iWin32VersionValue,"@0")>>
\SizeOfImage:                 <<TRANSFORM(loDump.iSizeOfImage,"@0")>>
\SizeOfHeaders:               <<TRANSFORM(loDump.iSizeOfHeaders,"@0")>>
\CheckSum:                    <<TRANSFORM(loDump.iCheckSum,"@0")>>
\Subsystem:                   <<TRANSFORM(loDump.iSubsystem,"@0")>>
\DllCharacteristics:          <<TRANSFORM(loDump.iDllCharacteristics,"@0")>>
\SizeOfStackReserve:          <<TRANSFORM(loDump.iSizeOfStackReserve,"@0")>>
\SizeOfStackCommit:           <<TRANSFORM(loDump.iSizeOfStackCommit,"@0")>>
\SizeOfHeapReserve:           <<TRANSFORM(loDump.iSizeOfHeapReserve,"@0")>>
\SizeOfHeapCommit:            <<TRANSFORM(loDump.iSizeOfHeapCommit,"@0")>>
\LoaderFlags:                 <<TRANSFORM(loDump.iLoaderFlags,"@0")>>
\NumberOfRvaAndSizes:         <<TRANSFORM(loDump.iNumberOfRvaAndSizes,"@0")>>

\
\_IMAGE_DATA_DIRECTORY
\<<PADR("Name",20)>> VirtualAddress Size
\<<REPLI("-",20)>>--------------------------
FOR lii=1 TO loDump.iNumberOfRvaAndSizes
    loObj=loDump.aDataDirectory(lii)
    \<<PADR(loObj.cName,20)+" "+PADR(TRANSFORM(loObj.iVirtualAddress,"@0"),14)+" "+TRANSFORM(loObj.iSize,"@0")>>
NEXT




\
\_IMAGE_SECTION_HEADER
FOR lii=1 TO loDump.iNumberOfSections
    loObj=loDump.aSectionHeader(lii)
    \<<loObj.cName>>
    \<<CHR(9)+"VirtualSize:          "+TRANSFORM(loObj.iVirtualSize,"@0")>>
    \<<CHR(9)+"VirtualAddress:       "+TRANSFORM(loObj.iVirtualAddress,"@0")>>
    \<<CHR(9)+"SizeOfRawData:        "+TRANSFORM(loObj.iSizeOfRawData,"@0")>>
    \<<CHR(9)+"PointerToRawData:     "+TRANSFORM(loObj.iPointerToRawData,"@0")>>
    \<<CHR(9)+"PointerToRelocations: "+TRANSFORM(loObj.iPointerToRelocations,"@0")>>
    \<<CHR(9)+"PointerToLinenumbers: "+TRANSFORM(loObj.iPointerToLinenumbers,"@0")>>
    \<<CHR(9)+"NumberOfRelocations:  "+TRANSFORM(loObj.iNumberOfRelocations,"@0")>>
    \<<CHR(9)+"NumberOfLinenumbers:  "+TRANSFORM(loObj.iNumberOfLinenumbers,"@0")>>
    \<<CHR(9)+"Characteristics:      "+TRANSFORM(loObj.iCharacteristics,"@0")>>
NEXT


\
\_IMAGE_EXPORT_DIRECTORY
loObj=loDump.ExportDirectory

\Characteristics:       <<TRANSFORM(loObj.iCharacteristics,"@0")>>
\TimeDateStamp:         <<TRANSFORM(loObj.iTimeDateStamp,"@0")>>
\MajorVersion:          <<TRANSFORM(loObj.iMajorVersion,"@0")>>
\MinorVersion:          <<TRANSFORM(loObj.iMinorVersion,"@0")>>
*\Name:                  <<TRANSFORM(loObj.iName,"@0")>>
\Name:                  <<loObj.cName>>
\Base:                  <<TRANSFORM(loObj.iBase,"@0")>>
\NumberOfFunctions:     <<TRANSFORM(loObj.iNumberOfFunctions,"@0")>>
\NumberOfNames:         <<TRANSFORM(loObj.iNumberOfNames,"@0")>>
*\AddressOfFunctions:    <<TRANSFORM(loObj.iAddressOfFunctions,"@0")>>
*\AddressOfNames:        <<TRANSFORM(loObj.iAddressOfNames,"@0")>>
*\AddressOfNameOrdinals: <<TRANSFORM(loObj.iAddressOfNameOrdinals,"@0")>>

liMax=0
FOR lii=1 TO loObj.iNumberOfNames
    liMax=MAX(liMax,LEN(loObj.aNames(lii)))
NEXT

\
\ Order <<PADR("Name",liMax)>> Pointer        Ordinal 
\------<<REPLICA("-",liMax)>>------------------------
FOR lii=1 TO loObj.iNumberOfNames
    liy=loObj.aNameOrdinals(lii)+loObj.iBase
    \<<str(lii,6)>> <<PADR(loObj.aNames(lii),liMax)>> <<TRANSFORM(loObj.aFunctions(loObj.aNameOrdinals(lii)+1),"@0")>> <<STR(liy,11)>>
NEXT

*!*	\
*!*	FOR lii=1 TO loObj.iNumberOfFunctions
*!*	    IF ASCAN(loObj.aNameOrdinals,lii+1-loObj.iBase)=0
*!*	       \<<str(lii,6)>> <<TRANSFORM(loObj.aFunctions(lii),"@0")>>
*!*	    ENDIF
*!*	NEXT

\
\IMAGE_IMPORT_DESCRIPTOR


FOR lii=1 TO ALEN(loDump.aImportDescriptor,1)
    loObj=loDump.aImportDescriptor(lii)

    \
    \Name: <<loObj.cName>>
    \<<CHR(9)>>OriginalFirstThunk: <<TRANSFORM(loObj.iOriginalFirstThunk,"@0")>>
    \<<CHR(9)>>TimeDateStamp:      <<TRANSFORM(loObj.iTimeDateStamp,"@0")>>
    \<<CHR(9)>>iForwarderChain:    <<TRANSFORM(loObj.iForwarderChain,"@0")>>
    \<<CHR(9)>>FirstThunk:         <<TRANSFORM(loObj.iFirstThunk,"@0")>>

    liMax=0
    FOR liy=1 TO ALEN(loObj.aImportByName)
        loIT=loObj.aImportByName(liy)
        limax=MAX(liMax,LEN(loIT.cName))
    NEXT
    liMax=IIF(liMax<4,4,liMax)

    \
    \<<CHR(9)>>Order <<PADR("Name",liMax)>> Pointer
    \<<CHR(9)>>------<<REPL("-",liMax)>> ----------
    FOR liy=1 TO ALEN(loObj.aImportByName)
        loIT=loObj.aImportByName(liy)
        \<<CHR(9)+STR(loIT.iHint,5)>> <<PADR(loIT.cName,liMax)>> <<TRANSFORM(loIT.iPointer,"@0")>>
    NEXT

NEXT





IF loDump.iFoxTable>0
   \
   \
   \FoxTable: <<TRANSFORM(loDump.iFoxTable,"@0")>>
   \<<CHR(9)+"Reserved: "+TRANSFORM(loDump.aFoxTable(_aFT_Reserved),"@0")>>
   \<<CHR(9)+"Count:    "+TRANSFORM(loDump.aFoxTable(_aFT_Count),"@0")>>
   \<<CHR(9)+"FoxInfo:  "+TRANSFORM(loDump.aFoxTable(_aFT_FoxInfo),"@0")>>

   * Vpis FoxInfo
   IF loDump.aFoxTable(_aFT_Count)>0
      \
      \FoxInfo:
      FOR lii=1 TO loDump.aFoxTable(_aFT_Count)
          loObj=loDump.aFoxInfo(lii)
          \<<CHR(9)+"Name: "+loObj.cFuncName>>
          \<<CHR(9)+CHR(9)+"Pointer:        "+TRANSFORM(loObj.FPFI,"@0")>>
          \<<CHR(9)+CHR(9)+"Parmeter Count: "+STR(loObj.iParmCount,10)>>
          \<<CHR(9)+CHR(9)+"Parmeter List:  "+loObj.cParmTypes>>
      NEXT
   ENDIF

ENDIF
=__StopDoc()



******************************************
PROCEDURE __StartDoc(lcFile)
* lcFile - Nzev vstupnho souboru
LOCAL llErr,lcErr,lcSF
SET CONSOLE OFF
IF !EMPTY(lcFile)
   SET TEXTMERGE ON
   lcErr=ON("ERROR")
   ON ERROR llErr=.T.
   lcSF=SET("SAFETY")
   SET SAFETY OFF
   SET TEXTMERGE TO (lcFile)
   IF EMPTY(lcErr)
      ON ERROR
   ELSE
      ON ERROR &lcErr.
   ENDIF
   IF lcSF=="ON"
      SET SAFETY ON
   ELSE
      SET SAFETY OFF
   ENDIF
ELSE
   llErr=.T.
ENDIF
RETURN !llErr
ENDPROC

******************************************
PROCEDURE __StopDoc
SET CONSOLE OFF
SET TEXTMERGE TO
SET TEXTMERGE OFF
ENDPROC


